=== debian/changelog ===
passwordsafe (0.98.1+dfsg-3) unstable; urgency=medium

  * Apply Ubuntu patch from Gianfranco Costamagna to fix build failure
      when building with -Wl,--as-needed.
  * Refresh all quilt patches

 -- William Blough <devel@blough.us>  Tue, 05 Apr 2016 13:48:29 -0400

passwordsafe (0.98.1+dfsg-2) unstable; urgency=medium

  * Fix logic error in date conversion.  Fixes automated test
      failures on 32-bit platforms.
  * Renamed signing key to correct extension

 -- William Blough <devel@blough.us>  Sat, 02 Apr 2016 21:32:57 -0400

passwordsafe (0.98.1+dfsg-1) unstable; urgency=medium

  * New upstream version 
  * Fix some filenames in debian/copyright (Lintian fix)
  * Update lintian override for false positive
  * Update standards version to 3.9.7 (no changes needed)
  * Add upstream signing key and watch file pattern

 -- William Blough <devel@blough.us>  Sun, 28 Feb 2016 02:12:40 -0500

passwordsafe (0.97+dfsg-1) unstable; urgency=low

  * Initial release (Closes: #648067)

 -- William Blough <devel@blough.us>  Mon, 27 Apr 2015 23:02:47 -0400
