=== debian/control ===
Source: passwordsafe
Section: utils
Priority: optional
Maintainer: William Blough <devel@blough.us>
Build-Depends: debhelper (>= 9.0.0),
               libgtest-dev,
               libwxgtk3.0-dev,
               libxerces-c-dev,
               libxt-dev,
               libxtst-dev,
               libykpers-1-dev,
               libyubikey-dev,
               locales-all,
               pkgconf,
               uuid-dev,
               wx3.0-headers,
               zip
Standards-Version: 3.9.7
Homepage: http://pwsafe.org/
Vcs-Git: https://bitbucket.org/bblough/passwordsafe.git
Vcs-Browser: https://bitbucket.org/bblough/passwordsafe/src

Package: passwordsafe
Architecture: any
Conflicts: pwsafe
Depends: passwordsafe-common, ${misc:Depends}, ${shlibs:Depends}
Description: Simple & Secure Password Management
 Password Safe allows you to safely and easily create a secured and
 encrypted user name/password list. With Password Safe all you have to do
 is create and remember a single "Master Password" of your choice in order
 to unlock and access your entire user name/password list.
 .
 This is the GNU/Linux version of the popular PasswordSafe password
 manager, originally designed by the renowned security technologist
 Bruce Schneier and open sourced in 2002.
 .
 Compatible with 1.x, 2.x and 3.x versions of the database format.
 .
 Note: This is a BETA release for Linux, therefore some functionality
 may not yet be implemented.

Package: passwordsafe-common
Architecture: all
Depends: ${misc:Depends}
Recommends: passwordsafe
Description: architecture independent files for Password Safe
 Password Safe allows you to safely and easily create a secured and
 encrypted user name/password list. With Password Safe all you have to do
 is create and remember a single "Master Password" of your choice in order
 to unlock and access your entire user name/password list.
 .
 This is the GNU/Linux version of the popular PasswordSafe password
 manager, originally designed by the renowned security technologist
 Bruce Schneier and open sourced in 2002.
 .
 Compatible with 1.x, 2.x and 3.x versions of the database format.
 .
 This package contains the parts of Password Safe that are common
 to all architectures, including in-program help files.
 .
 Note: This is a BETA release for Linux, therefore some functionality
 may not yet be implemented.
