=== debian/watch ===
version=3

opts=\
pgpsigurlmangle=s/$/.sig/,dversionmangle=s/\+dfsg//,\
uversionmangle=s/(\d)[_\.\-\+]?((BETA)\d*)$/$1~$2/,\
filenamemangle=s/.+\/v?(\d\S*)\.tgz/pwsafe-$1\.tgz/ \
https://github.com/pwsafe/pwsafe/releases .*/pwsafe-(\d\S*)BETA-src\.(?:tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))
