## passwordsafe 0.99+dfsg

=== debian/changelog ===
passwordsafe (0.99+dfsg-1) unstable; urgency=medium

  * New upstream version.  Closes: 832381
  * Recommend xvkbd package.  Closes: 829406
  * Add patch from Reiner Herrmann for reproducible builds. Closes: 829261
  * Update standards version to 3.9.8 (no changes needed)
  * Remove unneeded patches and refresh remaining patches

 -- William Blough <devel@blough.us>  Mon, 25 Jul 2016 13:36:41 -0400
