=== debian/control ===
--- 
+++ 
@@ -15,7 +15,7 @@
                uuid-dev,
                wx3.0-headers,
                zip
-Standards-Version: 3.9.7
+Standards-Version: 3.9.8
 Homepage: http://pwsafe.org/
 Vcs-Git: https://bitbucket.org/bblough/passwordsafe.git
 Vcs-Browser: https://bitbucket.org/bblough/passwordsafe/src
@@ -24,6 +24,7 @@
 Architecture: any
 Conflicts: pwsafe
 Depends: passwordsafe-common, ${misc:Depends}, ${shlibs:Depends}
+Recommends: xvkbd
 Description: Simple & Secure Password Management
  Password Safe allows you to safely and easily create a secured and
  encrypted user name/password list. With Password Safe all you have to do
