=== src/ui/wxWidgets/Makefile ===
--- 
+++ 
@@ -37,8 +37,8 @@
 WXWIN=/usr/src/wxwidgets2.8-2.8.7.1
 TOOLCHAINNAME=gtk2d
 WXVERSION:=$(shell echo `$(WX_CONFIG) --version`)
-CXX=g++
-CC=gcc
+CXX?=g++
+CC?=gcc
 RESCOMP=windres.exe
 RCFILEOBJ=pwsafe_rc.o
 RCFILESRC=pwsafe.rc
@@ -47,7 +47,7 @@
 OBJECTPATH=GCCDebug
 BUILDPATHS=$(OBJECTPATH)
 PROGRAM=pwsafe
-LIBS=`$(WX_CONFIG) --debug=yes --unicode=no --libs` -lcore -los -lcore -luuid -lXtst -lX11 -l$(YBPERS_LIBS)
+LIBS=`$(WX_CONFIG) --debug=yes --unicode=no --libs` -lcore -los -lcore -luuid -lXtst -lX11 -l$(YBPERS_LIBS) ${LIBCXX_LD_EXTRA_FLAGS}
 LINKERFLAGS=
 WARNINGFLAGS=-Wall
 OPTFLAGS=-O0
@@ -64,8 +64,8 @@
 WXWIN=/usr/src/wxwidgets2.8-2.8.7.1
 TOOLCHAINNAME=gtk2
 WXVERSION:=$(shell echo `$(WX_CONFIG) --debug=no --unicode=no --version`)
-CXX=g++
-CC=gcc
+CXX?=g++
+CC?=gcc
 RESCOMP=windres.exe
 RCFILEOBJ=pwsafe_rc.o
 RCFILESRC=pwsafe.rc
@@ -91,8 +91,8 @@
 WXWIN=/usr/src/wxwidgets2.8-2.8.7.1
 TOOLCHAINNAME=gtk2ud
 WXVERSION:=$(shell echo `$(WX_CONFIG) --debug=yes --unicode=yes --version`)
-CXX=g++
-CC=gcc
+CXX?=g++
+CC?=gcc
 RESCOMP=windres.exe
 RCFILEOBJ=pwsafe_rc.o
 RCFILESRC=pwsafe.rc
@@ -119,8 +119,8 @@
 WXWIN=/usr/src/wxwidgets2.8-2.8.7.1
 TOOLCHAINNAME=gtk2u
 WXVERSION:=$(shell echo `$(WX_CONFIG) --debug=no --unicode=yes --version`)
-CXX=g++
-CC=gcc
+CXX?=g++
+CC?=gcc
 RESCOMP=windres.exe
 RCFILEOBJ=pwsafe_rc.o
 RCFILESRC=pwsafe.rc
@@ -169,7 +169,7 @@
 	optionspropsheet.cpp PasswordSafeSearch.cpp \
 	deleteconfirmation.cpp editshortcut.cpp \
 	createshortcutdlg.cpp SystemTray.cpp \
-	RUEList.cpp guiinfo.cpp ImportTextDlg.cpp \
+	guiinfo.cpp ImportTextDlg.cpp \
 	ImportXmlDlg.cpp OpenFilePickerValidator.cpp \
 	SafeCombinationCtrl.cpp ExportTextWarningDlg.cpp \
 	AdvancedSelectionDlg.cpp ViewReport.cpp dragbar.cpp \
@@ -179,7 +179,7 @@
 	fieldselectionpanel.cpp fieldselectiondlg.cpp pwsmenushortcuts.cpp \
 	$(YUBI_SRC) \
 	ManagePwdPolicies.cpp PasswordPolicy.cpp SelectionCriteria.cpp \
-	TimedTaskChain.cpp
+	TimedTaskChain.cpp mainView.cpp passwordsubset.cpp
 
 
 OBJECTS=$(SOURCES:%.cpp=$(OBJECTPATH)/%.o)
@@ -240,9 +240,13 @@
 	$(RM) $@.$$$$
 
 version.h: always
-	@../../../Misc/mkversion.pl MAJOR=$(VER_MAJOR) MINOR=$(VER_MINOR) SPECIAL=$(VER_SPECIAL) \
-     version.in $@
-
+ifdef VER_REV
+	@../../../Misc/mkversion.pl MAJOR=$(VER_MAJOR) MINOR=$(VER_MINOR) REV=$(VER_REV) \
+															SPECIAL=$(VER_SPECIAL) version.in $@
+else
+	@../../../Misc/mkversion.pl MAJOR=$(VER_MAJOR) MINOR=$(VER_MINOR) \
+															SPECIAL=$(VER_SPECIAL) version.in $@
+endif
 -include $(SOURCES:%.cpp=$(DEPDIR)/%.d)
