=== debian/changelog ===
passwordsafe (1.00+dfsg-1~bpo8+1) jessie-backports; urgency=medium

  * Rebuild for jessie-backports.

 -- William Blough <devel@blough.us>  Tue, 10 Jan 2017 20:58:54 -0500

passwordsafe (1.00+dfsg-1) unstable; urgency=medium

  * Change d/rules to eliminate depencdency on locales-all.  Thanks to
    Stephen Kitt for the bug report and patch.  Closes: 833533
  * Fix watch file
  * New upstream version
  * Remove reproducibe-build.patch, which was applied upstream.

 -- William Blough <devel@blough.us>  Mon, 07 Nov 2016 18:04:50 -0500

passwordsafe (0.98.1+dfsg-3~bpo8+1) jessie-backports; urgency=medium

  * Backport to jessie.

 -- Sergei Golovan <sgolovan@debian.org>  Mon, 02 May 2016 08:58:44 +0300
