=== debian/control ===
--- 
+++ 
@@ -10,7 +10,6 @@
                libxtst-dev,
                libykpers-1-dev,
                libyubikey-dev,
-               locales-all,
                pkgconf,
                uuid-dev,
                wx3.0-headers,
