=== debian/rules ===
--- 
+++ 
@@ -18,5 +18,5 @@
 	dh_installchangelogs --keep docs/ReleaseNotes.txt
 
 override_dh_auto_test:
-	LC_ALL=en_US.UTF-8 make release-test
+	LC_ALL=C.UTF-8 make release-test
